//
// Smooth.cpp:
//	Implementation of classes Channel and smooth.
//
// Purpose:
//      See "SMOOTH.HPP."
//
// Author(s): Mark Pflaging   C-serve  70233,1552
// Copyright 1992   Mark Thomas Pflaging
//
//
// Date:    5/15/92 - 6/4/92
//
#include "smooth.hpp"

char * smooth::title = "Smoothing";

int smooth::updateGloveData()
{
	// get data packet from glove
	int retval = cfGlove::updateGloveData();
	perform();
	return retval;
}

// Following two functions aren't terribly useful (yet).
void Channel::keepInBounds(smooth & rawData, GloveData::dimensions which)
{
	int x = rawData.getChannel(which);

	if ((x > (good_x + BOUND)) || (x < (good_x - BOUND))) {
		rawData.setChannel(which, good_x);
	}
	else {
		good_x = x;
	}
}

void smooth::keepInBounds(GloveData::dimensions which)
{
	if( getKeys() == 0 )
		for (int i = XChann; i <= which; i ++) (data[i])->zero();
	for ( int i = XChann; i < (which + 1); i ++)
		(data[i])->keepInBounds(*this, (GloveData::dimensions)i);
}

void Channel::hysteresis(smooth & rawData, GloveData::dimensions which)
{
	if (!HYST) return;
	int x = rawData.getChannel(which);
	if( rawData.getKeys() == 0 ) {
		// handle recentering ("0"key or "Center").
		ox = 0;
	}

	// one-dimensional hysterisis.

	if( x - ox > HYST ) {
		ox = x-HYST;
	}

	if( ox - x > HYST ) {
		ox = x + HYST;
	}
	rawData.setChannel(which, ox);
}

void smooth::hysteresis(GloveData::dimensions which)
{
	for ( int i = XChann; i <= which; i ++)
		(data[i])->hysteresis(*this, (GloveData::dimensions)i);
}

void Channel::deGlitch(smooth & rawData, GloveData::dimensions which)
{
	if ((!ACCEL) && (!EXTEND)) return;
	int x = rawData.getChannel(which);

	int vx = x - ( ( x1 + x2 ) >> 1 );

	x2 = x1;                       // update last values
	x1 = x;

	// check for extreme acceleration
	if( abs( lcx - vx ) > ACCEL ) {
		lax = EXTEND;
	}

/* Excuse me, excuse me....  why would you save this?
	// save only good velocity
	if( lax == 0 ) {
		lcx = vx;
	}
*/
	lcx = vx;       // save velocity for next accel.

	if( lax != 0 ) {	// hold X pos'n if glitch
		rawData.setChannel(which, lsx);
		lax--;
	}
	lsx = x;	// save position for X,Y hold
}

void smooth::deGlitch(GloveData::dimensions which)
{
	if( getKeys() == 0 )
		for (int i = XChann; i <= which; i ++) (data[i])->zero();
	for (int i = XChann; i <= which; i ++)
		(data[i])->deGlitch(*this, (GloveData::dimensions)i);
}
